function generate_map_simulation(t_start,duration,injection_name,fmin,fmax,factor,out_path)

% SIMU_GENERATE_MAP  injects a simulated waveform in Gaussian noise.
%   
%   RC = SIMU_GENERATE_MAP(T_START,DURATION,INJECTION_NAME,FMIN,FMAX,FACTOR,OUT_PATH) 
%
%   Arguments: 
%     T_START: GPS time start of the map
%     DURATION: duration in seconds of the map
%     INJECTION_NAME: name of the waveform (file must be in STAMPAS/waveforms/)
%     FMIN: minimal frequency of the map
%     FMAX: maximal frequency of the map
%     FACTOR: amplitude factor applied to the raw waveform
%     OUT_PATH: folder where results are stored
% 
%   Examples:
%     simu_generate_map(1234567890, 500, 'adi_A_tapered', 25, 300, 1, 'maps')
%
%   Author: 
%     Marie Anne Bizouard (mabizoua@lal.in2p3.fr)
%

t_start=strassign(t_start);
duration=strassign(duration);
fmin=strassign(fmin);
fmax=strassign(fmax);

if fmin>fmax
  error(['fmin should be lower than fmax'])
end

% absolute vs relative paths
rc=strfind(out_path,filesep);
if isempty(rc) | rc(1)>1
  out_path=[pwd '/' out_path];
end

if exist(out_path)==0
  system(['mkdir -p ' out_path]);
end

display(['Output will be stored in ' out_path]);

% get waveform duration to determine when the injection is done
filename=['../../waveforms/' injection_name '.dat'];
[void,s_duration]=system(['tail -1 ' char(filename) ' | cut -d " " -f 1']);
tmp=str2num(s_duration);
inj_duration=tmp(1);

delta_t=round((duration-inj_duration)/2.);
if delta_t<10
  error(['Injection must be done 10 s after the beginning of the' ...
	 ' map. Increase the window duration']);
end

% define end time of the window
t_end=strassign(t_start)+strassign(duration);

% segment duration
segDur=1;

% injection parameters
parameters.pair = 'H1L1';      
parameters.cachePath = 'cachefiles/';
parameters.doDetectorNoiseSim = 1;
parameters.DetectorNoiseFileLIGO = '../../PSDs/aLIGO_EarlyPSD_9Hz.txt';
parameters.DetectorNoiseFileVirgo = '../../PSDs/VirgoDesign_PSD_only.txt';
parameters.doAnteproc=false; 
parameters.run=get_run_from_GPStimes (t_start,t_end);
parameters.cacheSuffix = '';

parameters.doShift=1;
parameters.shiftTime=num2str(0);
parameters.largeShift=true;
parameters.largeShiftTime2=num2str(250);
    
% random injection polarization
parameters.doRandPol = false;
parameters.stampinj=true;
parameters.injfile=filename;
parameters.nameInj=injection_name;

% Other parameters
parameters.segmentDuration=segDur;
parameters.numSegmentsPerInterval=17;
parameters.ignoreMidSegment=true;

% Source coordinates
parameters.alpha=factor;
parameters.ra='8.9578';
parameters.decl='30.2263';
parameters.startGPS=num2str(t_start+delta_t);

% The pp_seed depends on the window index. The seed is reproducible
parameters.ppseed='1';

% When the polarization is generated by STAMPAS, one needs
% to be sure that it is the same for the group of 
% windows containing a single injection


parameters.fixedPol=true; 
rng(10000,'twister');
parameters.psi=num2str(rand*360);
parameters.iota=num2str(acosd(1-2*rand));

display(['inj start GPS: ' parameters.startGPS]);
display(['inj RA: ' parameters.ra]);
display(['inj decl: ' parameters.decl]);
display(['inj psi: ' parameters.psi]);
display(['inj iota: ' parameters.iota]);

% output file prefix
stoch_out.start=true;

% Load STAMP default parameters
params = stampDefaults;

% Load search parameters (generated by setup_config.m)
%load([out_path '/clustParam.mat']);
pair='H1L1';

% Parameters of the job
doDgPlots=1;
params.savePlots=true;

% save mat files
params.saveMat=true;

% create loop over search directions
params.skypatch = false;
params.fastring = false;

% sky resolution parameters
if strcmp(pair,'H1L1')
  params.dtheta=0.7;
else
  params.dtheta=0.3;
end
params.thetamax = 180;

% save all clusters
params.doAllClusters=true;

% min and max frequency of the search
params.fmin = strassign(fmin);
params.fmax = strassign(fmax);

if segDur < 1
  ff = params.fmin:(1/segDur):params.fmax;
  params.StampFreqsToRemove = intersect(ff,params.StampFreqsToRemove);
end

if segDur < 1
  params.glitch.doCut = false;
  params.glitch.numBands = 1;
  params.glitch.doCoincidentCut = false;
else
  % apply a glitch cut
  params.glitch.doCut = true;
  params.glitch.numBands = 3;
  params.glitch.doCoincidentCut = false;
  %  params.glitch.Xi_frac = 0.0027;
  params.glitch.Xi_frac = 0.15;
end

% perform a clustering search, use default burstegard parameters
params = burstegardDefaults(params);

% Uses zebragard to speed-up the search
params=zebragardDefaults(params);

% No matfiles available for injections. Injections are done in time domain.
params.matavailable=false;

% Use anteproc to pre-process injection data.
params.anteproc.loadFiles = true;

% fake jobfile
joblist=[1 t_start t_end duration 1];
dlmwrite([out_path '/joblist.txt'],joblist,'delimiter',' ','precision','%.8f');
params.jobsFile=[out_path '/joblist.txt'];

% Injections use different parameter files for each job
params.paramsFile = 'params_inj.txt';

% Save the injection parameters file. 
generate_param_file(params.paramsFile,parameters,pwd);

% Results and diagnostic plots folders 
save_dir=[parameters.nameInj];

% save events
params.injectionWindowIndex=1;
  
% Draw sky positions that are searched
rng(200,'twister');
  
% 5 positions are drawn
params.ra=rand(5,1)*24;                         % right ascension in hours
params.dec=(180/pi)*(acos(1-2*rand(5,1))-pi/2); % declination in degrees  

display(['RA: ' num2str(params.ra(1,1)) ' ' num2str(params.ra(2,1))]);
display(['dec: ' num2str(params.dec(1,1)) ' ' num2str(params.dec(2,1))]);
  
% start and end time to process

% Creates folder to save diagnostic plots if need be. One for each window
params.savePlots=true;
system(['mkdir -p ' out_path '/DiagPlots/plots_' save_dir '/plots_' num2str(t_start)]);
params.plotdir=[out_path '/DiagPlots/plots_' save_dir '/plots_' num2str(t_start)];

% Creates folder to save ft maps if need be. One for each window
system(['mkdir -p ' out_path '/DiagPlots/plots_' save_dir '/ftmaps_' num2str(t_start)]);
params.ftmapdir=[out_path '/DiagPlots/plots_' save_dir '/ftmaps_' num2str(t_start)];
  
% call clustermap
display(['t_start: ' num2str(t_start) ' t_end: ' num2str(t_end)]);
    
% call STAMP clustermap to process the current window
stoch_out=clustermap(params, t_start, t_end); 

% cleanup temporary file
system (['rm ' params.paramsFile]);
   
exit
